/***************************************************************************
                          gintegral.cpp  -  description
                             -------------------
    begin                : Tue Apr 23 2002
    copyright            : (C) 2002 by Alexei Soloviev, Alexander Polanski
    email                : solovjev@lynx.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gintegral.h"

GIntegral::GIntegral ( const int n, const double * xx, const double * ww )
  : order(n), x(xx), w(ww) {}
GIntegral::~GIntegral () {}

namespace Gaussian_quadrature {  // weights for Gaussian quadrature

  const double x4[] = {0.960289856497536, 0.796666477413627,
		       0.525532409916329, 0.183434642495650};
  const double w4[] = {0.101228536290376, 0.222381034453374,
		       0.313706645877887, 0.362683783378362};

  const double x8[] = {0.989400934991650, 0.944575023073233,
		       0.865631202387832, 0.755404408355003,
		       0.617876244402644, 0.458016777657227,
		       0.281603550779259, 0.095012509837637};
  const double w8[] = {0.027152459411754, 0.062253523938648,
		       0.095158511682493, 0.124628971255534,
		       0.149595988816577, 0.169156519395003,
		       0.182603415044924, 0.189450610455069};
}

const GIntegral GIntegral::g4()
{ 
  using namespace Gaussian_quadrature;
  return GIntegral ( 4, x4, w4 ); 
}
const GIntegral GIntegral::g8()
{ 
  using namespace Gaussian_quadrature;
  return GIntegral ( 8, x8, w8 ); 
}
