#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QLineEdit>
#include <QProcess>
#include <QtNetwork/QNetworkReply>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void updateStatus();

    void run();
    void processReadyReadStandardOutput();
    void processReadyReadStandardError();
    void processFinished();

    void save();
    void print();

    void drawData();
    void drawFit();

    void about();
    void site();

    void openFile();
    void saveConfig();

#ifdef Q_OS_WIN
    void replyFinished(QNetworkReply * reply);
#endif

private:
    Ui::MainWindow *ui;

    QProcess process;
    QAction * runAction;

    QString executable, command;
    QLineEdit status;
    QString x_min, x_max;
    QString dataFile;
    QString fitFile, infoFile;

    QUrl fitterUrl;
#ifdef Q_OS_WIN
    QNetworkAccessManager * networkAccessManager;
#endif

    void reopenConfig();

    void saveUIState();
    void loadUIState();

#ifdef Q_OS_WIN
    void checkForUpdate();
#endif
};

#endif // MAINWINDOW_H
