#ifndef PLOT_H
#define PLOT_H

#include "qcustomplot.h"

#include <QRubberBand>

class Plot : public QCustomPlot
{
    Q_OBJECT
public:
    explicit Plot(QWidget *parent = 0);
    
    void addGraphFromFile (const QString & filename,
                           const QString & name = QString(),
                           const QString & cols = QString() );
    int clearGraphs();

    bool trimsZeros;

signals:
    
public slots:

    void contextMenuRequest(QPoint pos);
    void onMousePress(QMouseEvent *event);
    void onMouseMove(QMouseEvent *event);
    void onMouseRelease(QMouseEvent *event);
    void onMouseDoubleClick(QMouseEvent *event);
    void moveLegend();
    void hideSelectedGraphs();
    void showSelectedGraphs();
    void selectionChanged();
    void setSelectedAxisLinear();
    void setSelectedAxisLogarithmic();

private:
    typedef struct rgb {
      unsigned char r, g, b;
    };
    static const rgb _easel[];
    static const unsigned int _easel_size;
    unsigned int _color_index;

    QRubberBand * rubberBand;
    QPoint rubberOrigin;
};

#endif // PLOT_H
